<?php
	// Defaults pertaining to the main feature
 	$config["defaults"]["main"]["features"]		= "options,announcements"; // Which options to display in the main feature
	$config["defaults"]["main"]["maxmail"]		= 5;		// Maximum number of mail entries to display in main
	$config["defaults"]["main"]["maxtodo"]		= 5;		// Maximum number of todo entries to display in main
	$config["defaults"]["main"]["maxmeetings"]	= 5;		// Maximum number of meeting entries to display in main
	$config["defaults"]["main"]["maxschedule"]	= 5;		// Maximum number of schedule entries to display in main

	// Defaults pertaining to the mail feature
        $config["defaults"]["mail"]["realname"]         = "";           // Default real name to use for the user (should usually be left blank)
        $config["defaults"]["mail"]["signature"]        = "";           // Default signauture line to use for the user
        $config["defaults"]["mail"]["linewrap"]         = 80;           // Where to wrap lines
        $config["defaults"]["mail"]["replyto"]          = "";           // Default Reply To setting
        $config["defaults"]["mail"]["pagesize"]         = 20;           // Default number of items to display in the mail list
        $config["defaults"]["mail"]["sortby"]           = "date";       // Default sort order (date|from|subject)
        $config["defaults"]["mail"]["sortorder"]        = 0;            // Default sort direction (0|1)
        $config["defaults"]["mail"]["dande"]            = 0;            // Delete and Expunge simulatiniously? (0|1)
        $config["defaults"]["mail"]["mande"]            = 0;            // Move and Expunge simulatiniously? (0|1)
        $config["defaults"]["mail"]["savesent"]         = 1;            // Save sent messages in the send folder? (0|1)
        $config["defaults"]["mail"]["sentfold"]         = "sent-mail";  // What folder to save sent messages to (can by anything, TWIG will create it if it does not exist)
        $config["defaults"]["mail"]["draftfold"]        = "Drafts";     // What folder to save draft messages to (can by anything, TWIG will create it if it does not exist)
        $config["defaults"]["mail"]["cmdline2"]         = 0;            // Display the second command line in mail (0|1)
        $config["defaults"]["mail"]["newwindow"]        = 0;            // Display messages in new windows (0|1)
        $config["defaults"]["mail"]["listcmds"]         = 0;            // Unused at the time
        $config["defaults"]["mail"]["newcontact"]       = 1;            // Show the contacts list when composing a new message (0|1)
	$config["defaults"]["mail"]["numup"]		= 1;		// Default number of attachments for new messages
 	$config["defaults"]["mail"]["mailtree"]		= 0;		// Display the mail view tree (0|1)
 	$config["defaults"]["mail"]["mtexpand"]		= 0;		// Allways expand all branches in the mail view tree (0|1)
 	$config["defaults"]["mail"]["mdn"]		= 0;		// Request a read receipts? (0|1)
 	$config["defaults"]["mail"]["mdn_mode"]		= 1;		// How to respond to MDN requests (0=never|1=manual|2=always)
 	$config["defaults"]["mail"]["areply"]		= 0;		// Included attached files when replying to a message (0|1)
 	$config["defaults"]["mail"]["aforward"]		= 1;		// Included attached files when forwarding a message (0|1)
 	$config["defaults"]["mail"]["clines"]		= 30;		// Number of body lines to display while composing a message
	$config["defaults"]["mail"]["dreturn"]		= 0;		// Always return to the main message list after deleting a message (0|1)
        $config["defaults"]["mail"]["fromaddress"]      = $login["username"] . "@" . $config["fromdomain"];
									// This will allow you to set the address that the user sends mail from, usually
                                                                        // this is set to the name the user logged in with and then the 'fromdomain' config
									// setting, however you may want to change this and strip out information from the
									// username or retreive the entire item from an external source like an LDAP server.


	// Defaults pertaining to the bookmarks feature
        $config["defaults"]["bookmarks"]["sortby"]      = "item";       // Default sort order (item|group|url)
        $config["defaults"]["bookmarks"]["sortorder"]   = 0;            // Default sort direction (0|1)
        $config["defaults"]["bookmarks"]["dgroup"]      = 0;            // Default group to add new items to (the group must alreay exist)
        $config["defaults"]["bookmarks"]["pagesize"]    = 20;           // Default number of items to display in the main list
        $config["defaults"]["bookmarks"]["viewgrp"]     = "*";          // Default group to display in the feature (*=All|0=Unfiled)

	// Defaults pertaining to the contacts feature
        $config["defaults"]["contacts"]["sortby"]       = "nickname";   // Default sort order (nickname|name|company|group|email)
        $config["defaults"]["contacts"]["sortorder"]    = 0;            // Default sort direction (0|1)
        $config["defaults"]["contacts"]["dgroup"]       = 0;           // Default group to add new items to (the group must alreay exist)
        $config["defaults"]["contacts"]["pagesize"]     = 20;           // Default number of items to display in the main list
        $config["defaults"]["contacts"]["viewgrp"]      = "*";          // Default group to display in the feature (*=All|0=Unfiled)

	// Global defaults
        $config["defaults"]["global"]["mstyle1"]        = 0;          	// Default TWIG feature list style (bold hyperlinks)
        $config["defaults"]["global"]["mstyle2"]        = 3;		// Default feature submenu style (non-bold hyperlinks)
        $config["defaults"]["global"]["tstyle1"]        = 5;		// Default tab style (tabs)
        $config["defaults"]["global"]["language"]       = $config["language"];          // Default language, this should be configured in config.inc.php3
        $config["defaults"]["global"]["mailfoot"]       = 0;            // Disabled the display of the new mail indicator in the footer (0|1)
        $config["defaults"]["global"]["prevnext"]       = "multitabs";	// Default paging indicator style (arrows|multitabs|multitabs+arrows|multitabs+arrows+fl|multitabs+words|multitabs+words+fl|select|select+arrows|tabs|tabs+select|tabs+select+arrows)
	$config["defaults"]["global"]["timeformat"]	= 12;		// Default time format

	// Defaults pertaining to the news feature
        $config["defaults"]["news"]["replyto"]          = "";           // Default Reply To setting
        $config["defaults"]["news"]["pagesize"]         = 20;		// Default max number of headers to retreive at once
        $config["defaults"]["news"]["newwindow"]        = 0;            // Display messages in new windows (0|1)
        $config["defaults"]["news"]["linewrap"]         = 80;           // Where to wrap lines
        $config["defaults"]["news"]["realname"]         = "";           // Default real name to use for the user (should usually be left blank)
        $config["defaults"]["news"]["signature"]        = "";           // Default signauture line to use for the user
        $config["defaults"]["news"]["inline"]        	= 0;           	// Display uuencoded images in message window

	// Defaults pertaining to the schedule feature
        $config["defaults"]["schedule"]["dgroup"]       = 0;            // Default group to add new items to (the group must alreay exist)
        $config["defaults"]["schedule"]["viewgrp"]      = "*";          // Default group to display in the feature (*=All|0=Unfiled)

	// Defaults pertaining to the todo feature
        $config["defaults"]["todo"]["sortby"]           = "priority";   // Default sort order (item|group|priority)
        $config["defaults"]["todo"]["sortorder"]        = 0;            // Default sort direction (0|1)
        $config["defaults"]["todo"]["dgroup"]           = 0;            // Default group to add new items to (the group must alreay exist)
        $config["defaults"]["todo"]["priority"]         = 0;            // Default priorty to set new items to
        $config["defaults"]["todo"]["pagesize"]         = 20;           // Default number of items to display in the main list
        $config["defaults"]["todo"]["viewgrp"]          = "*";          // Default group to display in the feature (*=All|0=Unfiled)
        $config["defaults"]["todo"]["duetype"]          = 0;            // Default due date type for items (0=Never|1=date|2=date/time)

	// Defaults pertaining to the notes feature
	$config["defaults"]["notes"]["sortby"]		= "item";	//  Default sort order (item|group)
	$config["defaults"]["notes"]["sortorder"]	= 0;		// Default sort direction (0|1)
	$config["defaults"]["notes"]["dgroup"]		= 0; 		// Default group to add new items to (the group must alreay exist)
	$config["defaults"]["notes"]["width"]		= 80;		// Default number of columns wide to make the text field
	$config["defaults"]["notes"]["height"]		= 24;		// Default number of rows long to make the text field
        $config["defaults"]["notes"]["pagesize"]        = 10;           // Default number of items to display in the main list
        $config["defaults"]["notes"]["viewgrp"]         = "*";          // Default group to display in the feature (*=All|0=Unfiled)

	$config["defaults"]["meetings"]["pagesize"]	= 20;		// Default number of rows of meetings in Meetings
	$config["defaults"]["meetings"]["mainview"] 	= "0";		// Default Meetings view
	$config["defaults"]["meetings"]["dgroup"]	= 0;		// Default group to add new items to (the group must alreay exist)
        $config["defaults"]["meetings"]["viewgrp"]      = "*";          // Default group to display in the feature (*=All|0=Unfiled)
?>
